function customEditEngineGetAngularScope () {
    var frm = document.getElementById("pageOptimizationFrame");
    if (!frm) {
        frm = document.getElementById("optimizationFrame");
        if (!frm) {
            return;
        }
    }

    var fw = frm.contentWindow;
    if(!fw || !fw.angular || !fw.$ || fw.$(".ng-scope").length == 0) {
        return;
    }

    return fw.angular.element(fw.$(".ng-scope")[1]).scope();
}

function optimizationInit(data) {
    return $.parseHTML("<iframe id=\"optimizationFrame\" width=\"100%\" height=\"100%\" frameborder='0' src=\""+jahiaGWTParameters.contextPath + jahiaGWTParameters.servletPath + "/editframe/default/" + jahiaGWTParameters.lang + data.getPath() + ".wem-edit-engine-opti.html\"/>")[0];
}

function optimizationPageInit(data) {
    return $.parseHTML("<iframe id=\"pageOptimizationFrame\" width=\"100%\" height=\"100%\" frameborder='0' src=\""+jahiaGWTParameters.contextPath + jahiaGWTParameters.servletPath + "/editframe/default/" + jahiaGWTParameters.lang + data.getPath() + ".wem-edit-engine-perso-page.html\"/>")[0];
}

function optimizationDoValidate(validation) {
    var angularScope = customEditEngineGetAngularScope();
    if (angularScope) {
        angularScope.validate(validation)
    }
}

function optimizationDoSave(node) {
    var angularScope = customEditEngineGetAngularScope();
    if (angularScope) {
        angularScope.save(node)
    }
}

function optimizationLanguageChange(data) {
    // nothing to do
}